java.lang

## Class InheritableThreadLocal<T>

- java.lang.Object
- - java.lang.ThreadLocal<T>
  - - java.lang.InheritableThreadLocal<T>

    public class InheritableThreadLocal<T>
    extends ThreadLocal<T>

This class extends `ThreadLocal` to provide inheritance of values from parent thread to child thread: when a child thread is created, the child receives initial values for all inheritable thread-local variables for which the parent has values. Normally the child's values will be identical to the parent's; however, the child's value can be made an arbitrary function of the parent's by overriding the `childValue` method in this class.

Inheritable thread-local variables are used in preference to ordinary thread-local variables when the per-thread-attribute being maintained in the variable (e.g., User ID, Transaction ID) must be automatically transmitted to any child threads that are created.

Since:
  1.2
See Also:
  `ThreadLocal`

### Constructor Summary

Constructors
Constructor and Description
`InheritableThreadLocal()`

### Method Summary

Methods
`protected T` `childValue(T parentValue)` Computes the child's initial value for this inheritable thread-local variable as a function of the parent's value at the time the child thread is created.

### Methods inherited from class java.lang.ThreadLocal

`get, initialValue, remove, set`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### InheritableThreadLocal

    public InheritableThreadLocal()

### Method Detail

#### childValue

    protected T childValue(T parentValue)

Computes the child's initial value for this inheritable thread-local variable as a function of the parent's value at the time the child thread is created. This method is called from within the parent thread before the child is started.

This method merely returns its input argument, and should be overridden if a different behavior is desired.

Parameters:
  `parentValue` - the parent thread's value
Returns:
  the child thread's initial value

Copyright © 1993, 2017, Oracle and/or its affiliates. All rights reserved.